--Ultimate Randomizer HUD Menu
--Made by Nightwolf

local urmain = assert(_URANDOM,"URANDOM: variables.lua isn't loaded properly!")

local HUDX = 40
local HUDY = 20
local HUDWINWIDTH = 240 //Maximum 320 (actual size is 4 units smaller due to the outline)
local HUDWINHEIGHT = 160 //Maximum 200
local HUDTEXTHEIGHT = 16 //Height between HUD texts
local MAXELEMENTS = (HUDWINHEIGHT/HUDTEXTHEIGHT)-2 //Currently 8

local HBUTTON_UP = 1
local HBUTTON_DOWN = 2
local HBUTTON_JUMP = 3
local HBUTTON_SPIN = 4

local function listnext(list)
	if type(list) != "table" return end
	if not list.selection then list.selection = 1 end
	if list.selection < #list.contents then
		list.selection = $1 + 1
	else
		list.selection = 1
	end
	list.selsound()
end

local function listprev(list)
	if type(list) != "table" return end
	if not list.selection then list.selection = 1 end
	if list.selection < 2 then
		list.selection = #list.contents
	else
		list.selection = $1 - 1
	end
	list.selsound()
end

local function clistmove(num,limit,fwd)
	if not num or not limit then return 1 end
	if fwd then
		if num < limit then return num+1 else return 1 end
	else
		if num < 2 then return limit else return num-1 end
	end
end

local function ishbuttonreleased(p,button)
	if button == HBUTTON_UP then
		if p.cmd.forwardmove <= 0 then return true end
	elseif button == HBUTTON_DOWN then
		if p.cmd.forwardmove >= 0 then return true end
	elseif button == HBUTTON_JUMP then
		if p.cmd.buttons & BT_JUMP == 0 then return true end
	elseif button == HBUTTON_SPIN then
		if p.cmd.buttons & BT_USE == 0 then return true end
	end
	return false
end

local function reversenum(tab,index)
	if not tab then return end
	if not index then return end
	if tab[index] == nil then return end
	if tab[index] == 0 or tab[index] == false
		tab[index] = 1
		return
	else
		tab[index] = 0
		return
	end
end

local function changelnum(huddata,num)
	if not huddata then return end
	if not num then num = 1 end
	huddata.listnum = num
	huddata.selection = 1
end

local function hudtimegoleft(huddata,self,time,minsec,maxmin)
	local tsec = time % 60
	local tmin = time / 60
	if self.selpart < 1 then return time end
	if self.issel then
		if self.selpart == 1 then 
			tmin = clistmove(tmin+1,maxmin,false)-1
			if tmin == 0 and tsec < minsec then tsec = 1 end
		elseif self.selpart == 2 then 
			if tmin == 0 then tsec = clistmove(tsec-minsec+1,60,false)+minsec-1 % 60
			else tsec = clistmove(tsec+1,60,false)-1 end
		end
	else 
		self.selpart = clistmove(self.selpart,2,false) 
	end
	return tmin * 60 + tsec
end

local function hudtimegoright(huddata,self,time,minsec,maxmin)
	local tsec = time % 60
	local tmin = time / 60
	if self.selpart < 1 then return time end
	if self.issel then
		if self.selpart == 1 then 
			tmin = clistmove(tmin+1,maxmin,true)-1
			if tmin == 0 and tsec < minsec then tsec = 1 end
		elseif self.selpart == 2 then
			if tmin == 0 then tsec = clistmove(tsec-minsec+1,60,true)+minsec-1 % 60
			else tsec = clistmove(tsec+1,60,true)-1 end
		end
	else 
		self.selpart = clistmove(self.selpart,2,true) 
	end
	return tmin * 60 + tsec
end

local hudcontents = {}
hudcontents[1] = {}
hudcontents[1][1] = {
	startstring = "\x88".."Ultimate Randomizer menu",
	string = "Character Randomizer",
	go = function(huddata)
		changelnum(huddata,2)
	end,
	back = function(huddata)
		huddata.selection = -1
	end,
}
hudcontents[1][2] = {
	string = "Object Randomizer",
	go = function(huddata)
		changelnum(huddata,3)
	end,
	back = function(huddata)
		huddata.selection = -1
	end,
}
hudcontents[1][3] = {
	string = "Map Randomizer",
	go = function(huddata)
		changelnum(huddata,4)
	end,
	back = function(huddata)
		huddata.selection = -1
	end,
}
hudcontents[1][4] = {
	string = "Physics Randomizer",
	go = function(huddata)
		changelnum(huddata,5)
	end,
	back = function(huddata)
		huddata.selection = -1
	end,
}
hudcontents[1][5] = {
	string = "Misc. Randomizer",
	go = function(huddata)
		changelnum(huddata,6)
	end,
	back = function(huddata)
		huddata.selection = -1
	end,
}
hudcontents[1][6] = {
	string = "-SAVE CONFIG-",
	go = function(huddata)
		huddata.sconfstr = urmain.cmds.saveconfig.run()
		changelnum(huddata,7)
	end,
	back = function(huddata)
		huddata.selection = -1
	end,
}
//Start of menu option definitions
hudcontents[2] = {}
hudcontents[2][1] = {
	startstring = "\x88".."Character randomizer options",
	string = "Enable",
	go = function(huddata)
		reversenum(urmain.var.charrandom,"isenabled")
		if urmain.var.charrandom.isenabled then urmain.cr_putskinsifnone() end
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		if urmain.var.charrandom.isenabled == 0 then return "\x85".."NO" else return "\x83".."YES" end
	end,
}
hudcontents[2][2] = {
	string = "Skin Time",
	selpart = 0,
	issel = false,
	go = function(huddata,self)
		if self.issel then self.issel = false
		elseif self.selpart > 0 then self.issel = true
		else self.selpart = 1 end
	end,
	left = function(huddata,self)
		local vars = urmain.var.charrandom
		vars.crtime = hudtimegoleft(huddata,self,vars.crtime,1,60)
	end,
	right = function(huddata,self)
		local vars = urmain.var.charrandom
		vars.crtime = hudtimegoright(huddata,self,vars.crtime,1,60)
	end,
	up = function(huddata,self)
		if self.selpart < 1 then 
			listprev(huddata)
		elseif not self.issel then
			self.selpart = 0
			listprev(huddata)
		end
	end,
	down = function(huddata,self)
		if self.selpart < 1 then 
			listnext(huddata)
		elseif not self.issel then
			self.selpart = 0
			listnext(huddata)
		end
	end,
	back = function(huddata,self)
		if self.issel then self.issel = false
		elseif self.selpart > 0 then self.selpart = 0
		else changelnum(huddata,1) end
		if self.selpart > 0 then self.selpart = 0 else changelnum(huddata,1) end
	end,
	printstr = function(huddata,self)
		local tictime = urmain.var.charrandom.crtime * TICRATE
		local rstr = ""
		local tsec = tostring(G_TicsToSeconds(tictime))
		if tsec:len() < 2 then tsec = "0"..$1 end
		if self.selpart == 1 then
			if self.issel then rstr = "\x87"..tostring(G_TicsToMinutes(tictime,true)).."\x82:"..tsec
			else rstr = "\x83"..tostring(G_TicsToMinutes(tictime,true)).."\x82:"..tsec end
		elseif self.selpart == 2 then
			if self.issel then rstr = "\x82"..tostring(G_TicsToMinutes(tictime,true))..":\x87"..tsec
			else rstr = "\x82"..tostring(G_TicsToMinutes(tictime,true))..":\x83"..tsec end
		else
			rstr = "\x82"..tostring(G_TicsToMinutes(tictime,true))..":"..tsec
		end
		return rstr
	end,
}
hudcontents[2][3] = {
	string = "Ultimate mode",
	go = function(huddata)
		reversenum(urmain.var.charrandom,"ultimate")
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		if urmain.var.charrandom.ultimate == 0 then return "\x85".."Disabled" else return "\x83".."Enabled" end
	end,
}
hudcontents[2][4] = {
	string = "SA2 Rando Mode",
	go = function(huddata)
		reversenum(urmain.var.charrandom,"sa2random")
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		if urmain.var.charrandom.sa2random == 0 then return "\x85".."Disabled" else return "\x83".."Enabled" end
	end,
}
hudcontents[2][5] = {
	string = "Skin Time Offset",
	selpart = 0,
	issel = false,
	go = function(huddata,self)
		if self.issel then self.issel = false
		elseif self.selpart > 0 then self.issel = true
		else self.selpart = 1 end
	end,
	left = function(huddata,self)
		local vars = urmain.var.charrandom
		vars.timeoffset = hudtimegoleft(huddata,self,vars.timeoffset,0,15)
	end,
	right = function(huddata,self)
		local vars = urmain.var.charrandom
		vars.timeoffset = hudtimegoright(huddata,self,vars.timeoffset,0,15)
	end,
	up = function(huddata,self)
		if self.selpart < 1 then 
			listprev(huddata)
		elseif not self.issel then
			self.selpart = 0
			listprev(huddata)
		end
	end,
	down = function(huddata,self)
		if self.selpart < 1 then 
			listnext(huddata)
		elseif not self.issel then
			self.selpart = 0
			listnext(huddata)
		end
	end,
	back = function(huddata,self)
		if self.issel then self.issel = false
		elseif self.selpart > 0 then self.selpart = 0
		else changelnum(huddata,1) end
		if self.selpart > 0 then self.selpart = 0 else changelnum(huddata,1) end
	end,
	printstr = function(huddata,self)
		local tictime = urmain.var.charrandom.timeoffset * TICRATE
		local rstr = ""
		local tsec = tostring(G_TicsToSeconds(tictime))
		if tsec:len() < 2 then tsec = "0"..$1 end
		if self.selpart == 1 then
			if self.issel then rstr = "\x87"..tostring(G_TicsToMinutes(tictime,true)).."\x82:"..tsec
			else rstr = "\x83"..tostring(G_TicsToMinutes(tictime,true)).."\x82:"..tsec end
		elseif self.selpart == 2 then
			if self.issel then rstr = "\x82"..tostring(G_TicsToMinutes(tictime,true))..":\x87"..tsec
			else rstr = "\x82"..tostring(G_TicsToMinutes(tictime,true))..":\x83"..tsec end
		else
			rstr = "\x82"..tostring(G_TicsToMinutes(tictime,true))..":"..tsec
		end
		return rstr
	end,
}
hudcontents[2][6] = {
	string = "Show next skin",
	go = function(huddata)
		reversenum(urmain.var.charrandom,"shownextskin")
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		if urmain.var.charrandom.shownextskin == 0 then return "\x85".."Disabled" else return "\x83".."Enabled" end
	end,
}
hudcontents[2][7] = {
	string = "Show skin timer",
	go = function(huddata)
		reversenum(urmain.var.charrandom,"showtimer")
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		if urmain.var.charrandom.showtimer == 0 then return "\x85".."Disabled" else return "\x83".."Enabled" end
	end,
}
hudcontents[3] = {}
hudcontents[3][1] = {
	startstring = "Object Randomizer options",
	string = "Enable",
	go = function(huddata)
		reversenum(urmain.var.objrandom,"isenabled")
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		if urmain.var.objrandom.isenabled == 0 then return "\x85".."NO" else return "\x83".."YES" end
	end,
}
hudcontents[3][2] = {
	string = "Object Position",
	go = function(huddata)
		if urmain.var.objrandom.setposition < 2 then urmain.var.objrandom.setposition = $1 + 1 else urmain.var.objrandom.setposition = 0 end
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		local sp = urmain.var.objrandom.setposition
		if sp == 0 then return "\x82".."Normal" elseif sp == 1 return "\x82".."Swap" elseif sp == 2 return "\x82".."Random" end
		return "\x8f".."error"
	end,
}
hudcontents[3][3] = {
	string = "Type randomization",
	go = function(huddata)
		if urmain.var.objrandom.randomtype < 4 then urmain.var.objrandom.randomtype = $1 + 1 else urmain.var.objrandom.randomtype = 0 end
		if urmain.var.objrandom.randomsize == 2 and urmain.var.objrandom.randomtype == 4 then urmain.var.objrandom.randomsize = 1 end
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		local rt = urmain.var.objrandom.randomtype
		if rt == 0 then return "\x82".."Disabled" elseif rt == 1 then return "\x82".."Limited" elseif rt == 2 then return "\x82".."Uniform" elseif rt == 3 then return "\x82".."Smart" elseif rt == 4 then return "\x85".."Full" end
		return "\x8f".."error"
	end,
}
hudcontents[3][4] = {
	string = "Size randomization",
	go = function(huddata)
		if urmain.var.objrandom.randomsize < 2 then urmain.var.objrandom.randomsize = $1 + 1 else urmain.var.objrandom.randomsize = 0 end
		if urmain.var.objrandom.randomsize == 2 and urmain.var.objrandom.randomtype == 4 then urmain.var.objrandom.randomtype = 3 end
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		local rt = urmain.var.objrandom.randomsize
		if rt == 0 then return "\x82".."Disabled" elseif rt == 1 then return "\x82".."Limited" elseif rt == 2 then return "\x82".."Max" end
		return "\x8f".."error"
	end,
}
hudcontents[4] = {}
hudcontents[4][1] = {
	startstring = "Map Randomizer options",
	string = "Enable",
	go = function(huddata)
		reversenum(urmain.var.maprandom,"isenabled")
		if #urmain.var.maprandom.maps == 0 then urmain.cmds.mr_randomize.run() end
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	up = function(huddata)
		return
	end,
	printstr = function(huddata)
		if urmain.var.maprandom.isenabled == 0 then return "\x85".."NO" else return "\x83".."YES" end
	end,
}
hudcontents[4][2] = {
	string = "Boss Maps",
	go = function(huddata)
		reversenum(urmain.var.maprandom,"bossmaps")
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		if urmain.var.maprandom.bossmaps == 0 then return "\x85".."Disabled" else return "\x83".."Enabled" end
	end,
}
hudcontents[4][3] = {
	string = "Special Stages",
	go = function(huddata)
		reversenum(urmain.var.maprandom,"specialstages")
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		if urmain.var.maprandom.specialstages == 0 then return "\x85".."Disabled" else return "\x83".."Enabled" end
	end,
}
hudcontents[4][4] = {
	string = "Auto-randomize",
	go = function(huddata)
		reversenum(urmain.var.maprandom,"autorandom")
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		if urmain.var.maprandom.autorandom == 0 then return "\x85".."Disabled" else return "\x83".."Enabled" end
	end,
}
hudcontents[4][5] = {
	string = "RANDOMIZE!",
	go = function(huddata)
		urmain.cmds.mr_randomize.run()
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	down = function(huddata)
		return
	end,
	printstr = function(huddata)
		return ""
	end,
}
hudcontents[4][6] = {
	string = "",
	go = function(huddata)
		return
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		return ""
	end,
}
hudcontents[4][7] = {
	string = "\x82".."Current: ",
	go = function(huddata)
		return
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		local vars = urmain.var.maprandom
		if vars.isenabled == 0 then return "\x85".."Disabled" end
		if #vars.maps == 0 then return "None" end
		if vars.maps[vars.mapnum] then return G_BuildMapTitle(vars.maps[vars.mapnum]) end
		return "None"
	end,
}
hudcontents[4][8] = {
	string = "\x82".."Next: ",
	go = function(huddata)
		return
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		local vars = urmain.var.maprandom
		if vars.isenabled == 0 then return "\x85".."Disabled" end
		if #vars.maps == 0 or #vars.maps <= vars.mapnum then return "None" end
		if vars.maps[vars.mapnum+1] then return G_BuildMapTitle(vars.maps[vars.mapnum+1]) end
		return "None"
	end,
}
hudcontents[5] = {}
hudcontents[5][1] = {
	startstring = "Physics Randomizer options",
	string = "Enable",
	go = function(huddata)
		reversenum(urmain.var.physrandom,"isenabled")
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		if urmain.var.physrandom.isenabled == 0 then return "\x85".."NO" else return "\x83".."YES" end
	end,
}
hudcontents[5][2] = {
	string = "Cooldown",
	selpart = 0,
	issel = false,
	go = function(huddata,self)
		if self.issel then self.issel = false
		elseif self.selpart > 0 then self.issel = true
		else self.selpart = 1 end
	end,
	left = function(huddata,self)
		local vars = urmain.var.physrandom
		vars.phtime = hudtimegoleft(huddata,self,vars.phtime,1,60)
	end,
	right = function(huddata,self)
		local vars = urmain.var.physrandom
		vars.phtime = hudtimegoright(huddata,self,vars.phtime,1,60)
	end,
	up = function(huddata,self)
		if self.selpart < 1 then 
			listprev(huddata)
		elseif not self.issel then
			self.selpart = 0
			listprev(huddata)
		end
	end,
	down = function(huddata,self)
		if self.selpart < 1 then 
			listnext(huddata)
		elseif not self.issel then
			self.selpart = 0
			listnext(huddata)
		end
	end,
	back = function(huddata,self)
		if self.issel then self.issel = false
		elseif self.selpart > 0 then self.selpart = 0
		else changelnum(huddata,1) end
		if self.selpart > 0 then self.selpart = 0 else changelnum(huddata,1) end
	end,
	printstr = function(huddata,self)
		local tictime = urmain.var.physrandom.phtime * TICRATE
		local rstr = ""
		local tsec = tostring(G_TicsToSeconds(tictime))
		if tsec:len() < 2 then tsec = "0"..$1 end
		if self.selpart == 1 then
			if self.issel then rstr = "\x87"..tostring(G_TicsToMinutes(tictime,true)).."\x82:"..tsec
			else rstr = "\x83"..tostring(G_TicsToMinutes(tictime,true)).."\x82:"..tsec end
		elseif self.selpart == 2 then
			if self.issel then rstr = "\x82"..tostring(G_TicsToMinutes(tictime,true))..":\x87"..tsec
			else rstr = "\x82"..tostring(G_TicsToMinutes(tictime,true))..":\x83"..tsec end
		else
			rstr = "\x82"..tostring(G_TicsToMinutes(tictime,true))..":"..tsec
		end
		return rstr
	end,
}
hudcontents[5][3] = {
	string = "Random Speed",
	go = function(huddata)
		if urmain.var.physrandom.speed < 2 then urmain.var.physrandom.speed = $1 + 1 else urmain.var.physrandom.speed = 0 end
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		local sp = urmain.var.physrandom.speed
		if sp == 0 then return "\x82".."Disabled" elseif sp == 1 return "\x82".."Limited" elseif sp == 2 return "\x82".."Full" end
		return "\x8f".."error"
	end,
}
hudcontents[5][4] = {
	string = "Random Spindash",
	go = function(huddata)
		if urmain.var.physrandom.spindash < 2 then urmain.var.physrandom.spindash = $1 + 1 else urmain.var.physrandom.spindash = 0 end
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		local sp = urmain.var.physrandom.spindash
		if sp == 0 then return "\x82".."Disabled" elseif sp == 1 return "\x82".."Limited" elseif sp == 2 return "\x82".."Full" end
		return "\x8f".."error"
	end,
}
hudcontents[5][5] = {
	string = "Random Friction",
	go = function(huddata)
		if urmain.var.physrandom.friction < 2 then urmain.var.physrandom.friction = $1 + 1 else urmain.var.physrandom.friction = 0 end
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		local th = urmain.var.physrandom.friction
		if th == 0 then return "\x82".."Disabled" elseif th == 1 return "\x82".."Limited" elseif th == 2 return "\x82".."Full" end
		return "\x8f".."error"
	end,
}
hudcontents[5][6] = {
	string = "Random Jump",
	go = function(huddata)
		if urmain.var.physrandom.jumping < 2 then urmain.var.physrandom.jumping = $1 + 1 else urmain.var.physrandom.jumping = 0 end
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		local th = urmain.var.physrandom.jumping
		if th == 0 then return "\x82".."Disabled" elseif th == 1 return "\x82".."Limited" elseif th == 2 return "\x82".."Full" end
		return "\x8f".."error"
	end,
}
hudcontents[5][7] = {
	string = "Random ActionSpd",
	go = function(huddata)
		if urmain.var.physrandom.actionspd < 2 then urmain.var.physrandom.actionspd = $1 + 1 else urmain.var.physrandom.actionspd = 0 end
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		local th = urmain.var.physrandom.actionspd
		if th == 0 then return "\x82".."Disabled" elseif th == 1 return "\x82".."Limited" elseif th == 2 return "\x82".."Full" end
		return "\x8f".."error"
	end,
}
hudcontents[5][8] = {
	string = "Show timer",
	go = function(huddata)
		reversenum(urmain.var.physrandom,"showtimer")
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		if urmain.var.physrandom.showtimer == 0 then return "\x85".."Disabled" else return "\x83".."Enabled" end
	end,
}
hudcontents[6] = {}
hudcontents[6][1] = {
	startstring = "Misc. Randomizer options",
	string = "Random Texture",
	go = function(huddata)
		if urmain.var.miscrandom.texturerand < 2 then urmain.var.miscrandom.texturerand = $1 + 1 else urmain.var.miscrandom.texturerand = 0 end
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		local sp = urmain.var.miscrandom.texturerand
		if sp == 0 then return "\x82".."Disabled" elseif sp == 1 return "\x82".."Swap" elseif sp == 2 return "\x82".."Randomize" end
		return "\x8f".."error"
	end,
}
hudcontents[6][2] = {
	string = "Random Flat",
	go = function(huddata)
		if urmain.var.miscrandom.flatrand < 2 then urmain.var.miscrandom.flatrand = $1 + 1 else urmain.var.miscrandom.flatrand = 0 end
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		local sp = urmain.var.miscrandom.flatrand
		if sp == 0 then return "\x82".."Disabled" elseif sp == 1 return "\x82".."Swap" elseif sp == 2 return "\x82".."Randomize" end
		return "\x8f".."error"
	end,
}
hudcontents[6][3] = {
	string = "Random Brightness",
	go = function(huddata)
		if urmain.var.miscrandom.brightrand < 2 then urmain.var.miscrandom.brightrand = $1 + 1 else urmain.var.miscrandom.brightrand = 0 end
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		local sp = urmain.var.miscrandom.brightrand
		if sp == 0 then return "\x82".."Disabled" elseif sp == 1 return "\x82".."Relative" elseif sp == 2 return "\x82".."Absolute" end
		return "\x8f".."error"
	end,
}
hudcontents[6][4] = {
	string = "Random Color",
	go = function(huddata)
		reversenum(urmain.var.miscrandom,"colorrand")
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		if urmain.var.miscrandom.colorrand == 0 then return "\x85".."Disabled" else return "\x83".."Enabled" end
	end,
}
hudcontents[6][5] = {
	string = "Random Ability",
	go = function(huddata)
		reversenum(urmain.var.miscrandom,"abilityrand")
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	printstr = function(huddata)
		if urmain.var.miscrandom.abilityrand == 0 then return "\x85".."Disabled" else return "\x83".."Enabled" end
	end,
}
hudcontents[7] = {}
hudcontents[7][1] = {
	startstring = "Config Save Result",
	string = "",
	go = function(huddata)
		changelnum(huddata,1)
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
	up = function(huddata)
		return
	end,
	down = function(huddata)
		return
	end,
	printstr = function(huddata)
		return huddata.sconfstr
	end,
}
hudcontents[7][2] = {
	string = "Press jump or spin to continue...",
	go = function(huddata)
		changelnum(huddata,1)
	end,
	back = function(huddata)
		changelnum(huddata,1)
	end,
}
//End of menu option definitions

//Credit to Flame for the 3 lines of code below
addHook("JumpSpecial", function(p) return p.urhudon end)
addHook("SpinSpecial", function(p) return p.urhudon end)
addHook("JumpSpinSpecial", function(p) return p.urhudon end)

addHook("PlayerThink",function(p)
	if not p.urhudon then return end
	if not p.urhud then 
		p.urhud = {} 
		p.urhud.selection = 1
		p.urhud.listnum = 1
		p.urhud.pressed = 0
		p.urhud.sidepress = false //Left and right presses are checked differently as L/R functions require constant input
		p.urhud.selsound = function()
			S_StartSound(nil,sfx_menu1,p)
		end
	end
	p.urhud.contents = hudcontents[p.urhud.listnum]
	local sel = p.urhud.selection
	local cont = p.urhud.contents
	local sidemove = p.cmd.sidemove
	local fwdmove = p.cmd.forwardmove
	if p.mo then
		p.mo.momx = 0
		p.mo.momy = 0
	end
	if p.cmd.buttons & BT_CUSTOM1 != 0 or sel < 0 then
		p.urhudon = false
		p.urhud = nil
		return
	elseif sidemove > 0 then
		if p.urhud.sidepress then p.urhud.sidepress = false; return end
		if cont[sel].right then cont[sel].right(p.urhud,cont[sel]) end
		p.urhud.sidepress = true
	elseif sidemove < 0 then
		if p.urhud.sidepress then p.urhud.sidepress = false; return end
		if cont[sel].left then cont[sel].left(p.urhud,cont[sel]) end
		p.urhud.sidepress = true
	elseif p.urhud.pressed then
		if ishbuttonreleased(p,p.urhud.pressed) then p.urhud.pressed = 0 end
		return
	elseif fwdmove > 0 then
		p.urhud.pressed = HBUTTON_UP
		if cont[sel].up then cont[sel].up(p.urhud,cont[sel]) else listprev(p.urhud) end
	elseif fwdmove < 0 then
		p.urhud.pressed = HBUTTON_DOWN
		if cont[sel].down then cont[sel].down(p.urhud,cont[sel]) else listnext(p.urhud) end
	elseif p.cmd.buttons & BT_JUMP != 0 then
		p.urhud.pressed = HBUTTON_JUMP
		if cont[sel].go then cont[sel].go(p.urhud,cont[sel]) end
	elseif p.cmd.buttons & BT_USE != 0 then
		p.urhud.pressed = HBUTTON_SPIN
		if cont[sel].back then cont[sel].back(p.urhud,cont[sel]) end
	end
end)

hud.add(function(v,p,cam)
	if not p.urhudon or not p.urhud then return end
	if not p.urhud.selection or not p.urhud.contents then return end
	if p.urhud.selection < 1 then return end
	v.drawFill(HUDX,HUDY,HUDWINWIDTH,HUDWINHEIGHT,152) //drawing the outline box
	v.drawFill(HUDX+2,HUDY+2,HUDWINWIDTH-4,HUDWINHEIGHT-4,150) //drawing the background box
	local textx = HUDX+4 //X of value description (left border)
	local valuex = HUDX+HUDWINWIDTH-4 //X of value string (right border)
	local starttexty = HUDY+4 //Start Y of HUD text
	local startstr = hudcontents[p.urhud.listnum][1].startstring
	if p.urhud.contents[p.urhud.selection].startstring then startstr = p.urhud.contents[p.urhud.selection].startstring end
	v.drawString(HUDX+(HUDWINWIDTH/2),starttexty,"\x88"..tostring(startstr),0,"center")
	local elemy = starttexty+HUDTEXTHEIGHT //Start Y of first interactive element (changes in the next for loop)
	local elemlimit = min(#p.urhud.contents,MAXELEMENTS)
	for f = 1,elemlimit do
		if p.urhud.selection == f then v.drawString(textx,elemy,"\x82"..p.urhud.contents[f].string,0,"left")
		else v.drawString(textx,elemy,p.urhud.contents[f].string,0,"left") end
		if p.urhud.contents[f].printstr then v.drawString(valuex,elemy,p.urhud.contents[f].printstr(p.urhud,p.urhud.contents[f]),0,"right") end
		elemy = $1+HUDTEXTHEIGHT
	end
end,"game")