--Misc. Randomizer (options that don't belong to other categories)
--Made by Nightwolf

local urmain = assert(_URANDOM,"URANDOM: variables.lua isn't loaded properly!")
local vars = urmain.var.miscrandom

local texturelist = {}
local flatlist = {}

local shufflearray = urmain.shufflearray

addHook("NetVars",function(net)
	texturelist = net(texturelist)
	flatlist = net(flatlist)
end)

local function isvarintab(tab,var)
	for k,v in pairs(tab) do
		if v == var then return true end
	end
	return false
end

addHook("MapLoad",function(mapnum)
	flatlist = {}
	texturelist = {}
	if vars.colorrand == 1 then
		for p in players.iterate do
			p.colrandcolor = P_RandomRange(1,#skincolors-1)
		end
	end
	if vars.abilityrand == 1 then
		for p in players.iterate do
			p.abrandability = P_RandomRange(CA_NONE,CA_TWINSPIN)
		end
	end
	if vars.texturerand > 0 then
		for side in sides.iterate do
			if vars.texturerand == 1 then
				table.insert(texturelist,side.toptexture)
				table.insert(texturelist,side.bottomtexture)
				table.insert(texturelist,side.midtexture)
			else
				if not isvarintab(texturelist,side.toptexture) then table.insert(texturelist,side.toptexture) end
				if not isvarintab(texturelist,side.bottomtexture) then table.insert(texturelist,side.bottomtexture) end
				if not isvarintab(texturelist,side.midtexture) then table.insert(texturelist,side.midtexture) end
			end
		end
		local tabindex = 1
		if vars.texturerand == 1 then
			shufflearray(texturelist,#texturelist)
		end
		for side in sides.iterate do
			if vars.texturerand == 1 then
				side.toptexture = texturelist[tabindex]
				side.bottomtexture = texturelist[tabindex+1]
				side.midtexture = texturelist[tabindex+2]
				tabindex = $1 + 3
			else
				local rnum = P_RandomRange(1,#texturelist)
				side.toptexture = texturelist[rnum]
				rnum = P_RandomRange(1,#texturelist)
				side.bottomtexture = texturelist[rnum]
				rnum = P_RandomRange(1,#texturelist)
				side.midtexture = texturelist[rnum]
			end
		end
	end
	if vars.flatrand > 0 then
		for sec in sectors.iterate do
			if vars.flatrand == 1 then
				table.insert(flatlist,sec.floorpic)
				table.insert(flatlist,sec.ceilingpic)
			else
				if not isvarintab(flatlist,sec.floorpic) then table.insert(flatlist,sec.floorpic) end
				if not isvarintab(flatlist,sec.ceilingpic) then table.insert(flatlist,sec.ceilingpic) end
			end
		end
		local tabindex = 1
		if vars.flatrand == 1 then
			shufflearray(flatlist,#flatlist)
		end
		for sec in sectors.iterate do
			if vars.flatrand == 1 then
				sec.floorpic = flatlist[tabindex]
				sec.ceilingpic = flatlist[tabindex+1]
				tabindex = $1 + 2
			else
				local rnum = P_RandomRange(1,#flatlist)
				sec.floorpic = flatlist[rnum]
				rnum = P_RandomRange(1,#flatlist)
				sec.ceilingpic = flatlist[rnum]
			end
		end
	end
	if vars.brightrand > 0 then
		for sec in sectors.iterate do
			if vars.brightrand == 1 then
				sec.lightlevel = $1 + P_RandomRange(-127,128)
			else
				sec.lightlevel = P_RandomRange(0,255)
			end
		end
	end
end)

addHook("PlayerThink",function(p)
	if vars.colorrand == 1 and p.colrandcolor then
		p.skincolor = p.colrandcolor
		if p.mo and not p.powers[pw_super] then p.mo.color = p.colrandcolor end
	end
	if vars.abilityrand == 1 and p.abrandability then
		p.charability = p.abrandability
	end
end)